#include <stdio.h>
#include <stdlib.h>

#include "tree.h"

int tree_insert(Tree *tree, int data) {
  Node *new_node = malloc(sizeof(Node));
  new_node->data = data;
  new_node->left = NULL;
  new_node->right = NULL;

  // If the tree is empty
  if (tree->root == NULL) {
    tree->root = new_node;
    return 0; // Early return
  }

  // If the tree is non-empty
  Node *cursor = tree->root;

  // An iterative (non-recursive approach) to tree insertion
  // While we look for a place to put our new node
  while (1) {
    // If larger than data
    if (new_node->data > cursor->data) {
      // If there is a child to the right
      if (cursor->right != NULL)
        cursor = cursor->right;
      else {
        cursor->right = new_node; // Put our node here
        break;                    // Break the outer while loop
      }
    }

    // If less-or-equal than our data
    if (new_node->data <= cursor->data) {
      // If there is a child to the left
      if (cursor->left != NULL)
        cursor = cursor->left;
      else {
        cursor->left = new_node; // Put our node here
        break;                   // Break the outer while loop
      }
    }
  }
}

bool tree_contains(Node *node, int data) {
  if (node == NULL)
    return false;

  if (node->data == data)
    return true;

  return tree_contains(node->left, data) || tree_contains(node->right, data);
}

int tree_remove(Node **node, int data) {
  if (node == NULL)
    return false;
  // TODO
}

int tree_clear(Node *node) {
  if (node == NULL)
    return 0;

  if (node->left != NULL)
    tree_clear(node->left);
  if (node->right != NULL)
    tree_clear(node->right);

  free(node);
  return 0;
}

int tree_size(Node *node) {
  if (node == NULL) {
    return 0;
  }

  return 1 + tree_size(node->left) + tree_size(node->right);
}
